﻿#Invoke-Office365SUMADR
#Written by Brian Kaler
#12/28/2018
#Modifies and Executes ADR
#Must be run on SCCM Server

#Load the SCCM Module
$SiteCode = "SSS" 
$SiteServer = "uswscm901.us.pinkertons.com" 

try {
    New-Item -Path HKCU:\Software\Microsoft\ConfigMgr10\AdminUI\MRU\1 -Force | Out-Null
    New-ItemProperty -Path HKCU:\Software\Microsoft\ConfigMgr10\AdminUI\MRU\1 -Name DomainName -Value "" -PropertyType String -Force | Out-Null
    New-ItemProperty -Path HKCU:\Software\Microsoft\ConfigMgr10\AdminUI\MRU\1 -Name ServerName -Value $SiteServer -PropertyType String -Force | Out-Null
    New-ItemProperty -Path HKCU:\Software\Microsoft\ConfigMgr10\AdminUI\MRU\1 -Name SiteCode -Value $SiteCode -PropertyType String -Force | Out-Null
    New-ItemProperty -Path HKCU:\Software\Microsoft\ConfigMgr10\AdminUI\MRU\1 -Name SiteName -Value "Primary Site $SiteCode" -PropertyType String -Force | Out-Null
} catch {
}
# Import the ConfigurationManager.psd1 module  
$scmod = Import-Module "$($ENV:SMS_ADMIN_UI_PATH)\..\ConfigurationManager.psd1"  

# Set the current location to be the site code. 
Set-Location $SiteCode":\" 

 

#Parameters
$appname = "Office 365"
$ADRRoot = "\\napwcfs01\itn_home01\SCCM\Windows Update\Office365 - ADR Packages"
$ADRName = "ADR - Office 365"
$frcollection = Get-CMCollection -name "MAINT-OFFICE365-FASTRING"
$wrcollection = Get-CMCollection -name "MAINT-OFFICE365-WIDERING"
$adrrulename = "$ADRName "+(get-date -format g)
$adrruledesc = "Generated by Invoke-ADR - ADR for $ADRName : "+(get-date -format g)
$adrpackagename = "AUTOPKG-OFFICE365-"+(get-date -format g)
$adrpackagedesc = "Generated by Invoke-ADR - Package for: "+(get-date -format g)
$adrpackagepath = ""
$frdeploymentname = "OFFICE365-FASTRING-"+(get-date -format g)
$wrdeploymentname = "OFFICE365-WIDE-"+(get-date -format g)
$deploymentdesc = "Generated by Invoke-ADR for $adrname on (get-date -format g)"
$dps = @(
        "USWDPS901.US.PINKERTONS.COM"
        "USEDPS901.US.PINKERTONS.COM"
        "USTDPS901.US.PINKERTONS.COM"
        "CATDPS901.US.PINKERTONS.COM"
        )


function Set-ADRDeploymentPackage
{
    [CMdletbinding()]
    Param
    (
        [Parameter(Mandatory = $true)]
        [wmi]$ADRObject,
        [Parameter(Mandatory = $true)]
        [string]$PackageID
        
    )
    try {
        [xml]$ContentTemplateXML = $ADRObject.ContentTemplate
        $ContentTemplateXML.ContentActionXML.PackageID = $PackageID
        $ADRObject.ContentTemplate = $ContentTemplateXML.OuterXml
        $ADRObject.Put() | Out-Null
        Write-Verbose "Succesfully commited updated PackageID"
    }
    catch {
        throw "Something went wrong setting the value"
    }
}

function Get-ADRInfo
{
    [CMdletbinding()]
    Param
    (
        [Parameter(Mandatory = $true)]
        [string]$ADRName,
        [Parameter(Mandatory = $true)]
        [string]$SiteCode,
        [Parameter(Mandatory = $true)]
        [string]$SiteServer
    )
    try 
    {
        $Namespace = "root/sms/site_" + $siteCode
        [wmi]$ADR = (Get-WmiObject -computername $siteserver -Class SMS_AutoDeployment -Namespace $Namespace | Where-Object -FilterScript {$_.Name -eq $ADRName}).__PATH
        return $ADR 
    }
    catch 
    {
        throw 'Failed to Get ADRInfo'
    }
}

function CreateFoldersbyDate(){
Param(
[Parameter(Mandatory=$true)]
[DateTime]$Date,
[Parameter(Mandatory=$true)]
[String]$path
)
$FolderYear = ($date | Get-Date -uformat "%Y")
$FolderMonth = ($date | Get-Date -UFormat "%m")
$FolderDay = ($date | Get-date -uformat "%d")
#create folder structure
$fyear = New-Item -ItemType Directory -name $folderyear -path filesystem::$path -Force -ErrorAction SilentlyContinue
$fmonth = New-Item -ItemType Directory -name $foldermonth -path filesystem::$path\$folderyear -Force -ErrorAction SilentlyContinue
$fday = New-Item -ItemType Directory -name $FolderDay -path filesystem::$path\$folderyear\$foldermonth  -Force -ErrorAction SilentlyContinue
return $fday
}
Function IsPatchDownloadTime(){
#set up some of our needed dates
$today = (Get-Date)
$maxtuesday = 13
$mintuesday = 7
$firstday = [DateTime]::new($today.year, $today.month, 1)
$cycle = $firstday

#Find the first tuesday
$i = 0
Do{
    $i = 1
    $cycle = $cycle.adddays($i)
    $firsttuesday = $cycle.day
    }While($cycle.dayofweek -ne "Tuesday")
#find the second tuesday
Do{
    $i = 1
    $cycle = $cycle.adddays($i)
    $secondtuesday = $cycle.day
    }While($cycle.dayofweek -ne "Tuesday")
#find the thirdtuesday
Do{
    $i = 1
    $cycle = $cycle.adddays($i)
    $thirdtuesday = $cycle.day
    }While($cycle.dayofweek -ne "Tuesday")


#If the second tuesday has passed and the third tuesday has not yet arrived, it's patch downloading time
if(($today.day -ge $secondtuesday) -and ($today.day -lt $thirdtuesday)){
Return $true
}
else
{
Return $false
}
}

#only download if it's after patch tuesday and before the next tuesday
If((IsPatchDownloadTime) -eq $false){
Exit
}


#Start Script here, or functionize


#create our folder structure for deployment package
$timestamp = get-date
$packagepath = Createfoldersbydate -date $timestamp -path $adrroot

#set up our package
$pkgobj = New-CMSoftwareUpdateDeploymentPackage -Name $adrpackagename -Description $adrpackagedesc -Path $packagepath.FullName

#add the package to our existing ADR
$adrobj = Get-ADRInfo -ADRName $adrname -SiteCode $sitecode -SiteServer $SiteServer
Set-ADRDeploymentPackage -ADRObject $adrobj -PackageID $pkgobj.packageid

#run our ADR 
Invoke-CMSoftwareUpdateAutoDeploymentRule -Name $ADRObj.name -verbose

#fetch our SUG
$sugname = $ADRname 

#Were the sugs created by the ADR recently otherwise clean up the package and exit.
$i = 0
Do{
        $i++
        Write-Host "WARNING: No SUG created yet, retry attempt $i of 5" 
        sleep -seconds 180
        $latestsug = Get-CMSoftwareUpdateGroup | where {($_.localizeddisplayname -match $sugname)} | Sort-Object DateCreated -Descending | select -first 1
        if($latestsug.DateCreated -ge (Get-date).addminutes(-15)){
        Break
        }
} While ($i -le 5)
if($i -eq 5){
    Write-Host "ERROR: Software update group was NOT created, this may indicate an internal SCCM error, packages will be removed."
    Remove-CMSoftwareUpdateDeploymentPackage -name $adrpackagename -force -confirm:$false
    Exit
}



#distribute our content
foreach($dp in $distributionpts){
    Start-CMContentDistribution -DeploymentPackageName $pkgobj.name -DistributionPointName $dp -confirm:$false -Verbose
    }


#cleanup any empty SUG or package created here

#if($mysug){
#Remove-CMSoftwareUpdateDeploymentPackage -name $adrpackagename -force -confirm:$false
#}

#distribute to our fastring users
IF((Get-CMSoftwareUpdateDeployment -Name $latestsug.LocalizedDisplayName) | Where {$_.TargetCollectionID -eq "SSS00089"}){
    Write-Host "An existing deployment was found, will not create the deployment."
    }
    Else
    {
    (New-CMSoftwareUpdateDeployment -VerbosityLevel AllMessages `
        -SoftwareUpdateGroupName $latestsug.LocalizedDisplayName `
        -CollectionName $frcollection.Name `
        -DeploymentName $frdeploymentname `
        -Description $deploymentdesc `
        -DeploymentType Required `
        -DeadlineDateTime (get-date).adddays(7) `
        -AvailableDateTime (get-date)
    )
    }


#distribute to our wide-deployment users
IF((Get-CMSoftwareUpdateDeployment -Name $latestsug.LocalizedDisplayName) | Where {$_.TargetCollectionID -eq "SSS00107"}){
    Write-Host "An existing deployment was found, will not create the deployment."
    }
    Else
    {
    (New-CMSoftwareUpdateDeployment -VerbosityLevel AllMessages `
        -SoftwareUpdateGroupName $latestsug.LocalizedDisplayName `
        -CollectionName $wrcollection.Name `
        -DeploymentName $wrdeploymentname `
        -Description $deploymentdesc `
        -DeploymentType Required `
        -DeadlineDateTime (get-date).adddays(29) `
        -AvailableDateTime (get-date).adddays(14)
    )
    }

#distribute our content
foreach($dp in $dps){
    Start-CMContentDistribution -DeploymentPackageName $pkgobj.name -DistributionPointName $dp -confirm:$false -Verbose
    }












